Subject: Re: git-archive and tar options

From: René Scharfe <[email-masked]>
Date: Thu, 14 Jul 2011 19:45:07 +0200

Am 14.07.2011 19:27, schrieb Jeff King:
> On Thu, Jul 14, 2011 at 07:16:24PM +0200, René Scharfe wrote:
> 
>>>> git archive --format=tar -o my.tar --transform 
>>>> 's,^Web/Templates/,myPath/myWeb/Templates/,' HEAD WebPortal/Templates/
>>>> error: unknown option `transform'
>>>
>>> Yeah, that won't work, because there is no such option. We do have
>>> "--prefix", but I suspect that's not flexible enough for what you want.
>>
>> If you only need a single subdirectory with a custom prefix you could do
>> something like this (variables only used to keep the lines short):
>>
>> 	$ subdir=WebPortal/Templates
>> 	$ prefix=myPath/myWeb/Templates/
>> 	$ (cd "$subdir" && git archive --prefix="$prefix" HEAD) >my.tar
>>
>> The output file can be specified with -o as well, of course, but you'd
>> either need to use an absolute path or add "../" for each directory
>> level you descend into (-o ../../my.tar in this case).
> 
> Couldn't you also do:
> 
>   git archive --prefix=$prefix HEAD:$subdir >my.tar
> 
> ? I guess that loses the pax header with the commit sha1 in it, though,
> because you are feeding a straight tree instead of a commit.

Yes, and yes.

> We didn't when git-archive was written, but these days we have
> get_sha1_with_context to remember incidental things about an object we
> look up. It should perhaps remember the commit (if any) we used to reach
> a treeish, and then the above command line could still insert the pax
> header.

That's a good idea to increase consistency, as there shouldn't really be
a difference in output between the two subdirectory syntaxes.

I always wondered, however, if the embedded commit ID has really been
used to identify the corresponding version of an archive that somehow
lost its filename (due to being piped?).

René